require "util"
require "defines"
require "story"

-- localisation shortcut
gt = game.gettext

game.oninit(function()
  game.player.force.disableallprototypes()
  game.mapsettings.enemy_expansion.enabled = false
  game.evolutionfactor = 0.6

  local recipelist = game.player.force.recipes
  recipelist["iron-plate"].enabled = true
  recipelist["copper-plate"].enabled = true
  recipelist["stone-brick"].enabled = true
  recipelist["wall"].enabled = true
  recipelist["wood"].enabled = true
  recipelist["stone-furnace"].enabled = true
  recipelist["iron-stick"].enabled = true
  recipelist["iron-axe"].enabled = true
  recipelist["wooden-chest"].enabled = true
  recipelist["iron-gear-wheel"].enabled = true
  recipelist["burner-mining-drill"].enabled = true
  recipelist["basic-transport-belt"].enabled = true
  recipelist["burner-inserter"].enabled = true
  recipelist["pump"].enabled = true
  recipelist["pipe"].enabled = true
  recipelist["pipe-to-ground"].enabled = true
  recipelist["boiler"].enabled = true
  recipelist["steam-engine"].enabled = true
  recipelist["electronic-circuit"].enabled = true
  recipelist["copper-cable"].enabled = true
  recipelist["pistol"].enabled = true
  recipelist["submachine-gun"].enabled = true
  recipelist["basic-bullet-magazine"].enabled = true
  recipelist["basic-armor"].enabled = true
  recipelist["basic-mining-drill"].enabled = true
  recipelist["basic-inserter"].enabled = true
  recipelist["small-electric-pole"].enabled = true
  recipelist["lab"].enabled = true
  recipelist["science-pack-1"].enabled = true
  recipelist["science-pack-2"].enabled = true
  recipelist["iron-chest"].enabled = true
  recipelist["repair-pack"].enabled = true
  
  local technologylist = game.player.force.technologies
  technologylist["steel-processing"].researched = true
  technologylist["optics"].researched = true
  technologylist["logistics"].researched = true
  technologylist["logistics-2"].researched = true
  technologylist["logistics-3"].enabled = true
  technologylist["automation"].researched = true
  technologylist["automation-2"].researched = true
  technologylist["flame-thrower"].enabled = true
  technologylist["electronics"].researched = true
  technologylist["advanced-electronics"].researched = true
  technologylist["military"].researched = true
  technologylist["military-2"].researched = true
  technologylist["turrets"].researched = true
  technologylist["armor-making"].researched = true
  technologylist["bullet-damage-1"].researched = true
  technologylist["bullet-damage-2"].researched = true
  technologylist["bullet-speed-1"].researched = true
  technologylist["bullet-speed-2"].researched = true
  technologylist["toolbelt"].researched = true
  technologylist["rocketry"].enabled = true
  technologylist["explosives"].researched = true
  technologylist["chemistry"].researched = true
  technologylist["automobilism"].researched = true
  technologylist["railway"].researched = true
  technologylist["automated-rail-transportation"].researched = true
  technologylist["rail-signals"].researched = true
  technologylist["advanced-material-processing"].researched = true
  technologylist["advanced-material-processing-2"].enabled = true
  technologylist["solar-energy"].researched = true
  technologylist["laser-turrets"].researched = true
  technologylist["electric-energy-accumulators-1"].researched = true
  technologylist["flammables"].enabled = true
  technologylist["rocket-travel"].reload()
  technologylist["rocket-travel"].enabled = true
  technologylist["modules"].enabled = true
  technologylist["speed-module"].enabled = true
  technologylist["speed-module-2"].enabled = true
  technologylist["effectivity-module"].enabled = true
  technologylist["effectivity-module-2"].enabled = true
  technologylist["productivity-module"].enabled = true
  technologylist["productivity-module-2"].enabled = true
  technologylist["alien-technology"].enabled = true
  technologylist["rocket-speed-1"].enabled = true
  technologylist["rocket-speed-2"].enabled = true
  technologylist["inserter-stack-size-bonus-1"].enabled = true
  technologylist["inserter-stack-size-bonus-2"].enabled = true
  technologylist["electric-energy-distribution-1"].researched = true
  technologylist["electric-energy-distribution-2"].enabled = true


  local character = game.player.character
  character.insert{name = "basic-transport-belt", count = 30}
  character.insert{name = "basic-inserter", count = 10}
  character.insert{name = "medium-electric-pole", count = 10}
  character.insert{name = "basic-mining-drill", count = 5}
  character.insert{name = "basic-transport-belt-to-ground", count = 6}
  character.insert{name = "long-handed-inserter", count = 10}
  character.insert{name = "assembling-machine-1", count = 2}
  character.insert{name = "wall", count = 100}
  character.insert{name = "laser-turret", count = 15}
  character.insert{name = "pipe", count = 10}
  character.insert{name = "boiler", count = 5}
  character.insert{name = "pump", count = 1}
  character.insert{name = "stone-furnace", count = 5}
  character.insert{name = "lab", count = 2}
  character.insert{name = "steam-engine", count = 5}
  character.insert{name = "iron-plate", count = 250}
  character.insert{name = "copper-plate", count = 150}
  character.insert{name = "coal", count = 100}
  character.insert{name = "iron-gear-wheel", count = 64}
  character.insert{name = "submachine-gun", count = 1}
  character.insert{name = "basic-bullet-magazine", count = 30}
  character.insert{name = "rocket-launcher", count = 1}
  character.insert{name = "rocket", count = 30}
  character.insert{name = "steel-axe", count = 1}
  character.insert{name = "heavy-armor", count = 1}
  character.insert{name = "small-lamp", count = 5}
  character.insert{name = "alien-artifact", count = 60}
  character.selectedgunindex = 1
end)

storytable =
{
  {
    {
      init = function() game.showmessagedialog(gt("msg-escaped")) end,
      condition = function() return game.getentitybytag("hungry-biter") == nil end,
      action =
      function()
        game.showmessagedialog(gt("msg-enemy-1"))
        game.showmessagedialog(gt("msg-enemy-2"))
        game.showmessagedialog(gt("msg-escape-1"))
        game.showmessagedialog(gt("msg-escape-2"))
        game.showmessagedialog(gt("msg-research-rocket-travel"))
      end
    },
    {
      action =
      function(event)
        game.player.setgoaldescription(gt("goal-research-rocket-travel"))
      end,
    },
    {
      init = function() glob.rockettechnology = game.player.force.technologies["rocket-travel"] end,
      condition = function() return glob.rockettechnology.researched end,
      action =
      function()
        game.showmessagedialog(gt("msg-finished"))
      end
    },
    {
      action =
      function()
        game.showmessagedialog(gt("msg-go-away"))
      end
    }
  }
}

mainstory = story.Story:new(storytable)

game.onsave(function()
  glob.storydata = mainstory:export()
end)

game.onload(function()
  mainstory:import(glob.storydata)
end)

function onwin()
  game.getplayer().setendingscreendata(gt("epilogue"), "factorio-theme-3.png")
end

game.onevent(defines.events, function(event)
  mainstory:update(event, "", onwin)
end)
